
****2008-2018年南北平衡发展指数计算过程
*请确定二级指标个数
local zb_ord2=17

****获取权重数据
foreach i of numlist 1(1)14 16(1)22{
import excel using "D:\平衡指数数据计算\权重数据集.xls", cellrange("A1:L32") clear sheet("`i'") 
	syntax [varlist]
	local wn= A[1]
	drop in 1
	local y=2008
	foreach v in `varlist'{
		if "`v'"=="A"{
		continue
		}
		ren `v' w`i'`y'
		local y=`y'+1
	}

	reshape long w`i',i(A) j(year)
	rename A prov
	label var w`i' "`wn'"
	qui replace w`i'=int(w`i')
save w`i',replace
}

import excel using "D:\平衡指数数据计算\权重数据集.xls",  clear sheet("15") 
	local wn= A[1]
	drop in 1
	syntax [varlist]
	local y=2008
	foreach v in `varlist'{
		if "`v'"=="A"{
		continue
		}
		ren `v' pop`y'
		local y=`y'+1
	}

	reshape long pop,i(A) j(year)
	replace pop=int(pop)
	rename A prov
	rename pop w15
	label var w15 "`wn'"
save w15,replace


use w1.dta,clear
forval i=2/22{
	merge 1:1 prov year using w`i'.dta
	drop _merge
}
save weight.dta,replace

import excel "D:\平衡指数数据计算\南北划分.xls",clear 
drop in 1
ren A prov 
ren B NS
save ns.dta,replace


******************************************************************************************************
******************************************************************************************************

****导入指标信息
import excel "D:\平衡指数数据计算\平衡发展指数指标体系（for code）+南北.xls", sheet("指标体系（计算版）") clear
drop if D==""
local zb=0
local num=_N
forval i=2/`num'{
	local zb=`zb'+1
	local bdi_vn_`zb'=D[`i']
	local DIR_`zb'=E[`i']
	local min_`zb'=real(F[`i'])
	local max_`zb'=real(G[`i'])
	local DQ_`zb'=H[`i']
	local CX_`zb'=I[`i']
	local L1_`zb'=J[`i']
	local L2_`zb'=K[`i']
	****该宏用于计算各指标地区不平衡的加权方案，8为等权重方案。
	local w`zb'=L[`i']
}

local TOT_N=`zb'



	forval zb=1/`TOT_N'{
		di "`zb': `bdi_vn_`zb''"

		local v_`zb'="`bdi_vn_`zb''"
	
		
		*************
		***当存在地区不平衡时，根据数据和不平衡测度方法计算。
		
	  capture import excel "D:\平衡指数数据计算\数据集xls\\`v_`zb''.xls",sheet("地区") cellrange("A1:F4")  clear
	  	if _rc!=0{
			continue
		}
		local w_nw=D[2]
		local wt=`w`zb''
		local wn=E[2]

	 capture import excel "D:\平衡指数数据计算\数据集xls\\`v_`zb''.xls",sheet("地区") cellrange("A6:L37")  clear all
	
		if _rc!=0 {
			continue
		}
		if A[1]==""{
			continue
		}
		drop in 1
		syntax [varlist]
		local y=2008
		foreach v in `varlist'{
			if "`v'"=="A"{
			continue
			}
			ren `v' y`y'
			local y=`y'+1
		}

		qui reshape long y,i(A) j(year)
		capture gen zb`zb' =real(y)
		if _rc!=0{
		rename y zb`zb'
		}
		
		rename A prov
		qui merge m:1 prov  using ns.dta,nogen
		qui merge 1:1 prov year using weight.dta,nogen

		
		foreach ns in "N" "S"{
			forval y=2008/2018{
				di  "`y'  `ns'"
				capture summ zb`zb' [fweight=w`wt'] if year==`y' & NS=="`ns'"
				local mean_`y'_`zb'_`ns'=r(mean)
				
				*********
				capture inequal7 zb`zb' [fweight=w`wt'] if year==`y' & NS=="`ns'"
				
				local ine5="gini index"
				local ine5_`y'_`zb'_`ns'=r(gini)
				
			}
		}

	}
	
	clear
	set obs `TOT_N'
	gen varn=""
	forval y=2011/2018{
		foreach ns in "S" "N"{
			gen `ns'_mean_`y'=.
			gen `ns'_gini_`y'=.
		}
	}
	forval zb=1/`TOT_N'{
	qui replace varn="`v_`zb''" in `zb'
		foreach ns in "S" "N"{
			forval y=2011/2018{
				capture  replace `ns'_mean_`y'=`mean_`y'_`zb'_`ns'' in `zb'
				capture  replace `ns'_gini_`y'=`ine5_`y'_`zb'_`ns'' in `zb'
			}
		}
	}
	
export excel using "D:\平衡指数数据计算\nb_bdi.xls", sheet("南北加权平均数值") sheetreplace firstrow(variables)

		

	***数据输出
	
foreach ns in "S" "N" {	

******************
***计算南北发展指数
        clear
		set obs 11
		gen year=2007+_n
		forval zb=1/`TOT_N'{
			qui gen bdi_`zb'=.
		}

		forval y=2008/2018{
			local n=`y'-2007
			forval zb=1/`TOT_N'{
				local vmin=`min_`zb''
				local vmax=`max_`zb''
				local DIR="`DIR_`zb''"
				if "`DIR'"=="正向"{
					 qui replace bdi_`zb'=100*(`mean_`y'_`zb'_`ns''-`vmin')/(`vmax'-`vmin')  in `n'
				}
				if "`DIR'"=="逆向"{
					qui replace bdi_`zb'=100*(`mean_`y'_`zb'_`ns''-`vmax')/(`vmin'-`vmax') in `n'
				}
			}	
		}
		save bdi_`ns'.dta,replace
	
		
	****二级指数计算	
		forval zb=1/`TOT_N'{
			label var bdi_`zb' "`L2_`zb''"
		}
		local k=0
		forval i=1/`zb_ord2'{
			ds,has(varl "`i'")
			local vl=r(varlist)	
			egen bdi2_`i'=rowmean(`vl')
			local num=wordcount("`vl'")
			local k=`k'+`num'
			label var bdi2_`i' "`L1_`k''"
		}
	****一级指数计算
		forval zb=1/`TOT_N'{
			label var bdi_`zb' " "
		}
		forval i=1/4{
			ds,has(varl "`i'")
			local vl=r(varlist)	
			egen bdi1_`i'=rowmean(`vl')
		}
	****总指数计算	
		
		egen  Tot_ine_dq=rowmean(bdi1_*)
		
		export excel using "D:\平衡指数数据计算\nb_bdi.xls", sheet("bdi(`ns')") sheetreplace firstrow(variables)

	
****************************
***计算南北地区不平衡

		clear
		set obs 11
		gen year=2007+_n
		forval zb=1/`TOT_N'{
			qui gen dq_ine_`zb'=.
		}

		forval y=2008/2018{
			local n=`y'-2007
			forval zb=1/`TOT_N'{
				capture qui replace dq_ine_`zb'=`ine5_`y'_`zb'_`ns'' in `n'
				qui replace dq_ine_`zb'=0 if dq_ine_`zb'==.
			}	
		}
		save dq_ine_`ns'.dta,replace
	
		
	****二级指数计算	
		forval zb=1/`TOT_N'{
			label var dq_ine_`zb' "`L2_`zb''"
		}
		local k=0
		forval i=1/`zb_ord2'{
			ds,has(varl "`i'")
			local vl=r(varlist)	
			egen dq_ine2_`i'=rowmean(`vl')
			local num=wordcount("`vl'")
			local k=`k'+`num'
			label var dq_ine2_`i' "`L1_`k''"
		}
	****一级指数计算
		forval zb=1/`TOT_N'{
			label var dq_ine_`zb' " "
		}
		forval i=1/4{
			ds,has(varl "`i'")
			local vl=r(varlist)	
			egen dq_ine1_`i'=rowmean(`vl')
		}
	****总指数计算	
		
		egen  Tot_ine_dq=rowmean(dq_ine1_*)
		
		export excel using "D:\平衡指数数据计算\nb_bdi.xls", sheet("g_ine(`ns')") sheetreplace firstrow(variables)

		
****************
***计算南北平衡发展指数		
	use bdi_`ns'.dta,clear	
	merge 1:1 year using dq_ine_`ns'.dta	
	
	forval zb=1/`TOT_N'{
		gen ibdi3_`zb'=bdi_`zb'*(1-dq_ine_`zb')
	}
	keep year ibdi3*
	
	****二级指数计算	
		forval zb=1/`TOT_N'{
			label var ibdi3_`zb' "`L2_`zb''"
		}
		local k=0
		forval i=1/`zb_ord2'{
			ds,has(varl "`i'")
			local vl=r(varlist)	
			egen ibdi2_`i'=rowmean(`vl')
			local num=wordcount("`vl'")
			local k=`k'+`num'
			label var ibdi2_`i' "`L1_`k''"
		}
	****一级指数计算
		forval zb=1/`TOT_N'{
			label var ibdi3_`zb' " "
		}
		forval i=1/4{
			ds,has(varl "`i'")
			local vl=r(varlist)	
			egen ibdi1_`i'=rowmean(`vl')
		}
	****总指数计算	
		
		egen  ibdi=rowmean(ibdi1_*)
		
		export excel using "D:\平衡指数数据计算\nb_bdi.xls", sheet("ibdi(`ns')") sheetreplace firstrow(variables)

	
		
}	
